\ simplepasm_B.fth
\ Version B supports RUNMOD modules
( Simple Pasm for P1 for Tachyon Forth V5.7 by CWE )
( beware: uses absolute cog adresses in startLMM, endLMM, for registers )
( Based on work from Peter Jakacki )
\ TACHYON 


FORGET SIMPLEPASM

module SIMPLEPASM	PRINT" Simple Tachyon PASM/LMM assembler " ;

( simple assembler for Tachyon Forth )

\ define some conditional execution words
byte ce

pri CE			ce C! ;
: if_z			%1010 CE ;
: if_nz			%0101 CE ;
: if_c			%1100 CE ;
: if_nc			%0011 CE ;
: always		%1111 CE ;
: never			0 CE ;

byte sr \ more than one is possible
\ define some results modifiers

pri SR+			sr C@ OR sr C! ;
pri SR-			NOT sr C@ AND sr C! ;
( with results - zcri )

: wc			%0100 SR+ ;
: wz			%1000 SR+ ;
: nr			%0010 SR- ;
: wr			%0010 SR+ ;

: imm %1 sr C@ OR sr C! ; \ immediate

\ define some PASM instructions
long op PRIVATE

: (OP) ( dest source iii --- ) \ new construct code CWE
    24 << \ i-field + zc
    sr C@ 22 << OR \ zcri field
    ce C@ 18 << OR \ cccc field
    OR \ source
    SWAP 9 << OR \ dest
    op !
    always
    %0010 sr C! 
;

long patchadr
: OP (OP) op @ patchadr @ ! 
    patchadr @ 4 + patchadr ! ;

' NOP COG@ $1FF AND := IP


: wrbyte		%000000_00 OP ; 
: rdbyte		%000000_10 OP ; 
: wrword		%000001_00 OP ; 
: rdword		%000001_10 OP ; 

: wrlong		%000010_00 OP ; 
: rdlong		%000010_10 OP ; 

: hubs			%000011_01 OP ; 
: clkset		0 hubs ;
: cogid			1 wr hubs ;
: coginit		2 hubs ;
: cogstop		3 hubs ;

: ror			%001000_10 OP ; 
: rol			%001001_10 OP ; 
: shr			%001010_10 OP ; 
: shl			%001011_10 OP ; 

: rcr			%001100_10 OP ; 
: rcl			%001101_10 OP ; 
: sar			%001110_10 OP ; 
: rev			%001111_10 OP ; 

: mins			%010000_10 OP ; 
: maxs			%010001_10 OP ; 
: min			%010010_10 OP ; 
: max			%010011_10 OP ; 

: movs			%010100_10 OP ; 
: movd			%010101_10 OP ; 
: movi			%010110_10 OP ; 

: jmpret		%010111_10 OP ; 
\ : (jmp)			%010111_00 OP ; 
\ : jmp			0 (jmp) ;
: jmp			%010111_00 OP ; 
\ : call    010111_11 OP X
\ : ret     X X (jmp)
: test			%011000_00 OP ; 
: testn			%011001_00 OP ; 

: and			%011000_10 OP ; 
: andn			%011001_10 OP ; 

: or			%011010_10 OP ; 
: xor			%011011_10 OP ; 

: muxc			%011100_10 OP ; 
: muxnc			%011101_10 OP ; 
: muxz			%011110_10 OP ; 
: muxnz			%011111_10 OP ; 

: add			%100000_10 OP ; 
: sub			%100001_10 OP ; 
: cmp			%100001_00 OP ; 
: addabs		%100010_10 OP ; 
: subabs		%100010_10 OP ; 

: sumc			%100100_10 OP ; 
: sumnc			%100101_10 OP ; 
: sumz			%100110_10 OP ; 
: sumnz			%100111_10 OP ; 

: mov			%101000_10 OP ; 
: neg			%101001_10 OP ; 
: abs			%101010_10 OP ; 
: absneg		%101011_10 OP ; 

: negc			%101100_10 OP ; 
: negnc			%101101_10 OP ; 
: negz			%101110_10 OP ; 
: negnz			%101111_10 OP ; 

: cmps			%110000_00 OP ; 
: cmpsx			%110001_00 OP ; 

: addx			%110010_10 OP ; 
: subx			%110011_10 OP ; 
: cmpx			%110011_00 OP ; 
: adds			%110100_10 OP ; 

: subs			%110101_10 OP ; 
: addsx			%110110_10 OP ; 
: subsx			%110111_10 OP ; 
: cmpsub		%111000_10 OP ; 

: djnz			%111001_10 OP ; 
: tjnz			%111010_00 OP ; 
: tjz			%111011_00 OP ; 

: waitpeq		%111100_00 OP ; 
: waitpne		%111101_00 OP ; 
: waitcnt		%111110_10 OP ; 
: waitvid		%111111_00 OP ; 

: nop			never 0 1 wrbyte ;

\ : jmpl			mov  IP ;

\ alias for top-of-stack
' DUP COG@ $1FF AND := tos
tos 1+ := par2
par2 1+ := par3
par3 1+ := par4
\ cog registers
$26 := R0
R0 1+ := R1
R1 1+ := R2

: startLMM \ start LMM Pasm code
    always \ setup assembler  
    %0010 sr C! 
    patchadr @ 2 + 4 MOD 0 <> IF \ Align pasm code to longs
        0 patchadr @ W! \ Fill with a wordcode NOP
        patchadr @ 2 + patchadr !     
    THEN
    $007C  \ starts the LMM loop
    patchadr @ W! 
    patchadr @ 2 + patchadr ! ;
; 

: endLMM \ end LMM Pasm code
    0 $5A nr imm jmp \ jump to EXIT
; 

: longalign ( adr -- nextaligned ) 
    DUP 3 AND DUP 0 <> IF 
        -   4 +
    ELSE DROP THEN ; 

: startMOD \ start PASM to be loaded as MOD
    always \ setup assembler  
    %0010 sr C! 
; 


\ Example ============================================================== 
\ Create the dummy executable word an  reserve space in its code field
: addL ( n1 n2 -- n1+n2 n2 ) \ reserve space
    0 \ startLMM needs 1 word, each literal is 2 bytes
    1 2 
    3 4 
    5 6 
    98 99 \ endLMM needs 1 long
;

\ Patch the PASM assembly code into the dummy word
' addL patchadr ! \ Start patching at CFA of the new word
startLMM
    par2 tos add \ pasm instruction add tos into par2
endLMM


\ Asm Tests ============================================================== 
\ Create the dummy executable word an  reserve space in its code field
: asmt ( ??? ) \ reserve space
    0 \ startLMM needs 1 word, each literal is 2 bytes
    1 2 
    3 4 
    5 6 
    98 99 \ endLMM needs 1 long
;

\ Patch the PASM assembly code into the dummy word
' asmt patchadr ! \ Start patching at CFA of the new word
startLMM
    \ par2 tos add \ pasm instruction add tos into par2 : works
    { R0 tos mov \ swap try R0 :  works
    tos par2 mov
    par2 R0 mov }
    tos 99 imm sub \ try imm works
    { tos 1 wz imm sub \ try decrement loop : works
    IP 8 imm if_nz sub   \  Jump relative -2*4 }   
endLMM

\ ======================================================================

: .BIN 
    base C@ SWAP 
    BINARY L>W 
    W>B . . SPACE 
    W>B . .
    base C! ;

\ ========================================================================
\ Fibonacci Benchmark
\ https://rosettacode.org/wiki/Fibonacci_sequence see 8080 code

\ Create the dummy executable word and  reserve space in its code field
: fiboasm ( n -- f ) \ LMM fibonacci
    0 \ startLMM needs 1 word, each literal is 2 bytes
    1 2
    2 2
    3 2
    4 2
    5 2
    6 2
    7 2
    8 2
    9 2
    10 2
    11 2
    12 2
    13 2
    
    99 2 \ endLMM needs 1 long    
;

{ \ version using stack
\ Patch the PASM assembly code into the dummy word
' fiboasm patchadr ! \ get the destination for patching
startLMM \ Start Patching
    
    par3 tos mov              \ FIBNCI: MOV  C,  A  ; C will store the counter
    par3 1 imm sub            \    DCR  C      ; decrement, because we know f(1) already
    tos 1 imm mov           \    MVI  A,  1
    par2 0 imm mov            \    MVI  B,  0
    par4 tos mov              \ LOOP:   MOV  D,  A
    tos par2 add              \    ADD  B      ; A := A + B
    par2 par4 mov               \    MOV  B,  D
    par3 1 wz imm sub         \    DCR  C
    IP 20 imm if_nz sub     \  Jump relative -5*4  JNZ  LOOP   ; jump if not zero
                    \ RET         ; return from subroutine   
                    
endLMM
}

\ version using registers R0 R1 R2
\ Patch the PASM assembly code into the dummy word
' fiboasm patchadr ! \ get the destination for patching
startLMM \ Start Patching
    R1 tos mov              \ FIBNCI: MOV  C,  A  ; C will store the counter
    R1 1 imm sub            \    DCR  C      ; decrement, because we know f(1) already
    tos 1 imm mov           \    MVI  A,  1
    R0 0 imm mov            \    MVI  B,  0
    R2 tos mov              \ LOOP:   MOV  D,  A
    tos R0 add              \    ADD  B      ; A := A + B
    R0 R2 mov               \    MOV  B,  D
    R1 1 wz imm sub         \    DCR  C
    IP 20 imm if_nz sub     \  Jump relative -5*4  JNZ  LOOP   ; jump if not zero
                    \ RET         ; return from subroutine                      
endLMM

\ version for RUNMOD ========================================================

4 15 * CARRAY _fibomod \ Create an array in code space to hold the code in hub memory

0 _fibomod longalign patchadr ! \ Start of code ist at the first aligned byte of the array 

startMOD \ start patching
    R1 tos mov              \ FIBNCI: MOV  C,  A  ; C will store the counter
    R1 1 imm sub            \    DCR  C      ; decrement, because we know f(1) already
    tos 1 imm mov           \    MVI  A,  1
    R0 0 imm mov            \    MVI  B,  0
    
    R2 tos mov              \ LOOP:   MOV  D,  A
    tos R0 add              \    ADD  B      ; A := A + B
    R0 R2 mov               \    MOV  B,  D
    R1 1 wz imm sub         \    DCR  C
    0 $1D9 4 + nr imm if_nz jmp     \  Jump to LOOP  JNZ  LOOP   ; jump if not zero
    0 $5D nr imm jmp \ jmp to doNEXT
\ endMOD no action

: [fibomod] \ load the new code
    0 _fibomod longalign \ get start in hub ram
    $01D9 \ destination adr in cog ram always the same place
    OVER patchadr @ SWAP - 4 / \ length longs
    LOADMOD
;

\ =============================================================================


: fibo1 ( n -- f )  \ Fibonacci Reihe, liefert letztes Ergebnis
    \ 0 1  ROT FOR BOUNDS NEXT DROP \ https://forums.parallax.com/discussion/167868/taqoz-tachyon-forth-for-the-p2-boot-rom/p7
    0 1 
    ROT 1 - FOR 
        SWAP OVER  
        + 
    NEXT
    SWAP DROP
;

: fitest 
    CR 46 LAP fibo LAP 
        ." Fast with BOUNDS:      " . .LAP 
    CR 46 LAP fibo1 LAP 
        ." Standard Forth words:  " . .LAP 
    CR 0 0 0 46 LAP fiboasm LAP 
        ." LMM PASM:              " . 
        DROP DROP DROP .LAP 
    CR 46 LAP [fibomod] RUNMOD LAP 
        ." cog PASM incl LOADMOD: " . .LAP 
    CR 46 [fibomod] LAP RUNMOD LAP 
        ." cog PASM excl LOADMOD: " . .LAP 
;

{ 
Results: 

Fast with BOUNDS:      1836311903 5,008 cycles = 62.600us
Standard Forth words:  1836311903 13,072 cycles = 163.400us
LMM PASM:              1836311903 7,456 cycles = 93.200us
cog PASM incl LOADMOD: 1836311903 5,296 cycles = 66.200us
cog PASM excl LOADMOD: 1836311903 944 cycles = 11.800us  ok
 }



